##
#
##

import uuid
import re

# role enum
ROLE_GUEST = 0
ROLE_USER = 1
ROLE_STAFF = 128

class User:
    """A user of the system."""

    def __init__(self, uid = None):
        if uid is None:
            self.uid = uuid.uuid4()
        else:
            self.uid = uid
        self.name = ""
        self.role = ROLE_GUEST
        self.sessions = set()

    @property
    def id_str(self) -> str:
        """Get this accounts ID as a string"""
        return str( self.uid )

    def has_access(self, level) -> bool:
        """Check if a user has at least an access level"""
        return self.role >= level

    def set_name(self, name):
        """Set this user's known as name"""
        self.name = re.sub(r'[^\w -]', '', name)
