#
# Utilities
#


def status_payload(client, connected=True):
    """Encode a client status update"""
    return {
            'sid': client.id,
            'uid': client.user.uid,
            'name': client.user.name,
            'role': client.user.role,
            'connected': connected
            }

def group_json_one(server, team_id, members):
    """Encode a single group id and its members"""
    return {
            'id': team_id,
            'members': [ str( member ) for member in members ],
            'names': [ server.users.get_name( member ) for member in members ]
        }

def group_json_many(server, teams):
    """Encode many groups and their members"""
    all_teams = []
    for team_id, members in enumerate(teams):
        payload = group_json_one( server, team_id, members )
        all_teams.append( payload )
    return all_teams


def decode_allocate( message ):
    """Decode an allocate request message"""
    data = message.get('data', {})
    ideal_size = int(data.get('idealSize', 4))
    min_size = int(data.get('minSize', 2))
    method = data.get('method', 'members')
    return ideal_size, min_size, method
